/****************************************************************************************************************************************	
* :																																		*
* 																												*
* 																																		*
* Software Version 1.0																													*
* 																																		*
* for details.																															*
* Chip type           : ATMEGA168																										*
* Clock frequency     : Internal clock 8 Mhz 																							*
****************************************************************************************************************************************/

/*********************************************
*					   			 			 *
*			Includs							 *
*											 *
*********************************************/

 		


#include 	<avr/io.h>
#include 	<stdint.h>
#include	"lcd.h"
#include 	<inttypes.h>
#include 	<stdio.h>
#include 	<avr/interrupt.h>
#ifndef 	F_CPU
#define 	F_CPU 		8000000L     
#endif 
#include 	<util/delay.h>
#include 	<avr/eeprom.h>

int	linie [31]= 	{	30,	41,55,73,96,124,157,196,		// Messpunkte in 5 Grad schritten 
							240,289,342,398,455,512,566,		// Fr Ntc 10KOHM
							619,667,712,752,788,819,847,
							870,891,909,924,937,948,
							958,966,974};
uint8_t mux, test, i;
double result, multiplikator, abstand ;
int diff,hilfe;
char buffer[32 ];

int main (void)
{
	for(mux = 0; mux <6;mux++ )
	{
		mux= 0;													// Multiplexer forsiert
		ADMUX = mux;                      						
		ADMUX |= (0<<REFS1) | (1<<REFS0) | (0<<ADLAR); 			
		ADCSRA |= (1<<ADSC);             						
		i  = 0;	
		result = 0;
		for( i=0; i<40; i++ )		
		{
			ADCSRA |= (1<<ADSC);							// eine Wandlung "single conversion"
			while ( ADCSRA & (1<<ADSC) )
			{
				;  										// auf Abschluss der Konvertierung warten
			}
			result += ADC;		    						// Wandlungsergebnisse aufaddieren
		}
		result /= 40; 											//Mittelwert bildung 
		test = 0;				
		for(test = 0;test < 31;test++)							//For schleifen initialisierung zur ermittlung des ergebnisses
		{
			if	(result >= linie[30])						//wenn der Messwert grer Linie [30] ist
			{
				result = 9999;								//Sensor hat Plusschluss
				break;										//for Schleife wird verlassen
			}
			else if (result <= 26)							//wenn der Messwert kleiner gleich 26 ist						
			{
				result = -9999;								//Sensor hat Masseschluss
				break;										//for Schleife wird verlassen
			}
			else if	(linie[test] > result)					//Austesten wo sich das ergebniss befindet
			{
			hilfe = test - 1;								//hilfsvariable erzeugen
			diff=(result-linie[hilfe]);						//Differenz zwischen Linie und Messwert bilden
			abstand = (linie[test]-linie[hilfe]);			//Abstand zwischen denn zwei Punkten der linie ermitteln in der man sich befindet
			multiplikator = (5/ abstand);					//Faktor ermittlung indem 5 (5schritte ) mit dem Abstand difidiert wirt
			result= ((-40+(5*hilfe))+(multiplikator*diff));		//Das messergebnis endspricht dann temperaturwert der berschritten wured + ( Faktor mal der differenz)
			break;											//for Schleife wird verlassen
			}
		}
		lcd_gotoxy(0,0);							
		sprintf(buffer,"IST %3.1f ",result);		
		lcd_puts(buffer);
	}
}
